//+------------------------------------------------------------------+
//|                                        AlertIndicatorCombine.mq4 |
//|                                                 Peter Storozenko |
//|                                               pitpiter@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Peter Storozenko"
#property link      "pitpiter@gmail.com"
#property version   "1.00"

#property indicator_chart_window
extern bool AlertOnClosedBar=true;
extern bool PopUpAlert=true;
extern bool SoundAlert=true;
extern string Sound="alert";
extern bool EmailAlert=false;
extern string __="Moving Average setting";
extern ENUM_TIMEFRAMES MA_TimeFrame1=PERIOD_CURRENT;
extern bool UseTF2=false;
extern ENUM_TIMEFRAMES MA_TimeFrame2=PERIOD_M15;
extern bool UseTF3=false;
extern ENUM_TIMEFRAMES MA_TimeFrame3=PERIOD_H1;
extern int MA1_Period=35;
extern int MA1_Shift=0;
extern ENUM_MA_METHOD MA1_Method=0;
extern ENUM_APPLIED_PRICE  MA1_PriceApply=0;
extern int MA2_Period=50;
extern int MA2_Shift=0;
extern ENUM_MA_METHOD MA2_Method=1;
extern ENUM_APPLIED_PRICE  MA2_PriceApply=0;
extern string ___="Genesis Matrix setting";
extern int       Gen_TimeFrame_Period=0;        
extern int       Gen_TimeFrame_Auto=0;          
extern string    _______="TVI_Settings";
extern int       TVI_r=12;
extern int       TVI_s=12;
extern int       TVI_u=5;
extern string    ____="CCI_Settings";
extern int       CCI_Period=20;
extern double    CCI_Threshold=60;
extern string    _____="T3_Settings";
extern int       T3_Period=8;
extern int       T3_BarCount=1500;
extern string    ______="GannHiLo_Settings";
extern int       GannHiLo_Period=10;
extern string ________="ASC Trend Matrix setting";


extern int       ASC_TimeFrame_Period1=0; 
extern int       ASC_TimeFrame_Period2=0;        
extern bool       ASC_TimeFrame_Auto=true; 

extern int  ASC_TrendRisk=6;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int bar=0;
datetime nextalert;
bool BuySide=false,SellSide=false,BuyAlert=false,SellAlert=false;

int OnInit()
  {
    nextalert=0;
    if(AlertOnClosedBar)bar=1;    
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   double closP=NormalizeDouble(Close[bar],Digits);
   bool BuyMATF1=false,BuyMATF2=false,BuyMATF3=false,SellMATF1=false,SellMATF2=false,SellMATF3=false;
   double ma1=NormalizeDouble(iMA(Symbol(),MA_TimeFrame1,MA1_Period,MA1_Shift,MA1_Method,MA1_PriceApply,bar),Digits);
   double ma2=NormalizeDouble(iMA(Symbol(),MA_TimeFrame1,MA2_Period,MA2_Shift,MA2_Method,MA2_PriceApply,bar),Digits);
   if(ma1<closP&&ma2<closP)BuyMATF1=true;
   if(ma1>closP&&ma2>closP)SellMATF1=true;
   if(UseTF2)
   {
     ma1=NormalizeDouble(iMA(Symbol(),MA_TimeFrame2,MA1_Period,MA1_Shift,MA1_Method,MA1_PriceApply,bar),Digits);
     ma2=NormalizeDouble(iMA(Symbol(),MA_TimeFrame2,MA2_Period,MA2_Shift,MA2_Method,MA2_PriceApply,bar),Digits); 
     if(ma1<closP&&ma2<closP)BuyMATF2=true;
     if(ma1>closP&&ma2>closP)SellMATF2=true;       
   }
   else
   {
     BuyMATF2=true;
     SellMATF2=true;
   }
   if(UseTF3)
   {
     ma1=NormalizeDouble(iMA(Symbol(),MA_TimeFrame3,MA1_Period,MA1_Shift,MA1_Method,MA1_PriceApply,bar),Digits);
     ma2=NormalizeDouble(iMA(Symbol(),MA_TimeFrame3,MA2_Period,MA2_Shift,MA2_Method,MA2_PriceApply,bar),Digits); 
     if(ma1<closP&&ma2<closP)BuyMATF3=true;
     if(ma1>closP&&ma2>closP)SellMATF3=true;       
   }
   else
   {
     BuyMATF3=true;
     SellMATF3=true;
   } 
   double genes1=iCustom(Symbol(),0,"GenesisMatrix 2.22","",Gen_TimeFrame_Period,Gen_TimeFrame_Auto,"",TVI_r,TVI_s,TVI_u,"","",CCI_Period,
                 CCI_Threshold,"","",T3_Period,T3_BarCount,"","",GannHiLo_Period,"","",true,false,false,"","",White,0,bar); 
   double genes2=iCustom(Symbol(),0,"GenesisMatrix 2.22","",Gen_TimeFrame_Period,Gen_TimeFrame_Auto,"",TVI_r,TVI_s,TVI_u,"","",CCI_Period,
                 CCI_Threshold,"","",T3_Period,T3_BarCount,"","",GannHiLo_Period,"","",true,false,false,"","",White,1,bar);
   double genes3=iCustom(Symbol(),0,"GenesisMatrix 2.22","",Gen_TimeFrame_Period,Gen_TimeFrame_Auto,"",TVI_r,TVI_s,TVI_u,"","",CCI_Period,
                 CCI_Threshold,"","",T3_Period,T3_BarCount,"","",GannHiLo_Period,"","",true,false,false,"","",White,2,bar);
   double genes4=iCustom(Symbol(),0,"GenesisMatrix 2.22","",Gen_TimeFrame_Period,Gen_TimeFrame_Auto,"",TVI_r,TVI_s,TVI_u,"","",CCI_Period,
                 CCI_Threshold,"","",T3_Period,T3_BarCount,"","",GannHiLo_Period,"","",true,false,false,"","",White,3,bar);
   double genes5=iCustom(Symbol(),0,"GenesisMatrix 2.22","",Gen_TimeFrame_Period,Gen_TimeFrame_Auto,"",TVI_r,TVI_s,TVI_u,"","",CCI_Period,
                 CCI_Threshold,"","",T3_Period,T3_BarCount,"","",GannHiLo_Period,"","",true,false,false,"","",White,4,bar);
   double genes6=iCustom(Symbol(),0,"GenesisMatrix 2.22","",Gen_TimeFrame_Period,Gen_TimeFrame_Auto,"",TVI_r,TVI_s,TVI_u,"","",CCI_Period,
                 CCI_Threshold,"","",T3_Period,T3_BarCount,"","",GannHiLo_Period,"","",true,false,false,"","",White,5,bar);
   double genes7=iCustom(Symbol(),0,"GenesisMatrix 2.22","",Gen_TimeFrame_Period,Gen_TimeFrame_Auto,"",TVI_r,TVI_s,TVI_u,"","",CCI_Period,
                 CCI_Threshold,"","",T3_Period,T3_BarCount,"","",GannHiLo_Period,"","",true,false,false,"","",White,6,bar);
   double genes8=iCustom(Symbol(),0,"GenesisMatrix 2.22","",Gen_TimeFrame_Period,Gen_TimeFrame_Auto,"",TVI_r,TVI_s,TVI_u,"","",CCI_Period,
                 CCI_Threshold,"","",T3_Period,T3_BarCount,"","",GannHiLo_Period,"","",true,false,false,"","",White,7,bar); 
   bool Buyasc=false,Sellasc=false;
  int per=0;
  if(!ASC_TimeFrame_Auto)per=ASC_TimeFrame_Period1;   
   double val1=iCustom(Symbol(),per,"ASCTrend1i",ASC_TrendRisk,0,2,bar);
   double val2=iCustom(Symbol(),per,"ASCTrend1i",ASC_TrendRisk,0,2,bar+1);
   Buyasc=LastASC(0);
   Sellasc=LastASC(1);;                                                                                                                                   
   if(!BuySide)
   {
     if(genes1!=0&&genes3!=0&&genes5!=0&&genes7!=0&&val1==1&&val2==-1)
     {
       BuySide=true;
       SellSide=false;
       if(BuyMATF1&&BuyMATF2&&BuyMATF3)DoAlert("BUY");
     }
   }
   if(!SellSide)
   {
     if(genes2!=0&&genes4!=0&&genes6!=0&&genes8!=0&&val1==-1&&val2==1)
     {
       BuySide=false;
       SellSide=true;
       if(SellMATF1&&SellMATF2&&SellMATF3)DoAlert("SELL");
     }
   }
   return(rates_total);
  }
//+------------------------------------------------------------------+
bool LastASC(int dir)
{
  int per=0;
  if(!ASC_TimeFrame_Auto)per=ASC_TimeFrame_Period1;
  int shift=iBarShift(Symbol(),per,Time[1],false);
  double val=iCustom(Symbol(),per,"ASCTrend1i",ASC_TrendRisk,0,2,shift);
  if(dir==0&&val==1)return(true);
  if(dir==1&&val==-1)return(true);
  return(false);
}
void DoAlert(string text)
{
  string txt=text+" "+Symbol()+" "+Frame(Period())+" "+TimeToStr(TimeCurrent(),TIME_MINUTES);
  if(PopUpAlert)Alert(txt);
  if(EmailAlert)SendMail(txt,txt);
  if(SoundAlert)PlaySound(Sound);
  return;
}
string Frame(int a)
{
    string per;
            switch(a)
            {
              case 1 : per="M1";break;
              case 5 : per="M5";break;
              case 15: per="M15";break;
              case 30: per="M30";break;
              case 60: per="H1";break;
              case 240:per="H4";break;
              case 1440:per="D1";break;
              case 10080:per="W1";break;
              case 43200:per="MN";break;
            }
        return(per);
}


